#active_model Group Component
#1.00
#Group Component
#      
#ZH.F@zzu.edu.cn
#20070104
require "sketchup.rb"

class CombinEnts
  def add_edge(edge,comp)
    trans=comp.transformation.inverse
    e1=edge.start.position.transform! trans
    e2=edge.end.position.transform! trans
   
    if comp.typename =="Group" then
      ents = comp.entities
    else
      ents = comp.definition.entities
    end 
    ents.add_edges e1,e2
  end
 
  def add_curve(curve,comp)
    trans=comp.transformation.inverse
    ver=[]
    curve.vertices.each{|i| ver<< (i.position.transform! trans)}
    if comp.typename =="Group" then
      ents = comp.entities
    else
      ents = comp.definition.entities
    end 
    ents.add_curve ver
  end
  def add_arc(curve,comp)
    trans=comp.transformation.inverse
    puts "inin"
    tmp=[curve.vertices[0].position,curve.vertices[1].position]
    d1= tmp[0].distance( tmp[1])
    tmp.map!{|i| i.transform!(trans)}
    d2 = tmp[0].distance( tmp[1])
    d=  d2 /d1
    puts "d=#{d}"
    o=curve.center.transform! trans
    vx=curve.xaxis.transform! trans
    vn=curve.normal.transform! trans
    rd=curve.radius
    puts
    puts "rd=#{rd}"
    rd *= d
    puts rd
    sa=curve.start_angle
    ea=curve.end_angle
    if comp.typename =="Group" then
      ents = comp.entities
    else
      ents = comp.definition.entities
    end 
    ents.add_arc o,vx,vn,rd,sa,ea
  end
  def add_face_by_loop(loop,comp)
    trans=comp.transformation.inverse
    ver=[]
    loop.vertices.each{|i| ver<< (i.position.transform! trans)}
    if comp.typename =="Group" then
      ents = comp.entities
    else
      ents = comp.definition.entities
    end 
    ents.add_face ver
  end
  def add_face(face,comp)
    add_face_by_loop(face.outer_loop,comp)
    loops=face.loops
    loops.delete( face.outer_loop)
    loops.each{|i| comp.definition.entities.erase_entities  add_face_by_loop(i,comp)}
  end
  #?????
  def initialize
    #????????
    #@@nCursor = 0
  end
 
  #????
  def activate
    @model=Sketchup.active_model
    @selection=@model.selection
    @entities=@model.entities
    @ip = Sketchup::InputPoint.new
    Sketchup.active_model.start_operation "aaa"
    ss=[]
    cg=[]
    @selection.each{|i|
      case i.typename
      when "Edge"       
        if   (i.curve)
          ss << i.curve
        else
          ss << i
        end
      when "Face"
        ss << i
       
      when "ComponentInstance" , "Group"
        cg<< i
      end
    }
    ss=ss&ss
    puts ss.length
    ss.each{|i|
      self.add_edge(i, cg[0]) if i.typename=="Edge"
      self.add_arc(i, cg[0]) if i.typename=="ArcCurve"
      self.add_curve(i, cg[0]) if i.typename=="Curve"
      self.add_face(i, cg[0]) if i.typename=="Face"
    }
    Sketchup.active_model.commit_operation
  end
end


def combinEntsCanRun?
  ss=Sketchup.active_model.selection
  cg=[]
  ncg=[]
  ss.each{|i|
    if ["Group","ComponentInstance"].include?(i.typename) then
      cg << i
    else
      ncg << i
    end}
    puts cg
    puts ncg
  return nil if (cg.length <1 or ncg.length  < 1 )
  true
end

##
if( not file_loaded?("CombinEnts.rb") )
  #
  UI.menu("Plugins").add_item("Combin Ents") { Sketchup.active_model.select_tool CombinEnts.new }
  #
  UI.add_context_menu_handler do | menu |
    if combinEntsCanRun? then
      menu.add_separator
      menu.add_item("Combin Ents") { Sketchup.active_model.select_tool CombinEnts.new }
    end
  end
end
file_loaded("CombinEnts.rb")